#Throw Attack
execute as @e[type=wither_skeleton,tag=thor_boss,tag=!intro,tag=!Throw,scores={thor_Attack=49}] at @s if predicate techno_gow_weapons:is_target_in_throw_range if predicate techno_gow_weapons:random/50_per_cent run function techno_gow_weapons:bosses/thor/throw

#Recall Mjolnir
execute as @e[type=wither_skeleton,tag=thor_boss,tag=!intro,tag=Throw,scores={thor_Attack=49..}] at @s as @e[tag=thrown_mjolnir,tag=OnGround,tag=!return,distance=0..] if score @s mjolnir_ID = @e[tag=thor_boss,tag=!intro,tag=Throw,sort=nearest,limit=1] mjolnir_ID run function techno_gow_weapons:mjolnir/recall

#Attack Delay
scoreboard players add @e[type=wither_skeleton,tag=thor_boss] thor_Attack 1
scoreboard players reset @e[type=wither_skeleton,tag=thor_boss,scores={thor_Attack=50..}] thor_Attack

#Mellee attack
execute as @e[type=wither_skeleton,tag=thor_boss] at @s as @e[distance=..2,type=!player] run effect clear @s wither
execute as @a[tag=clear_wither] run effect clear @s wither
execute as @a[tag=clear_wither] run tag @s remove clear_wither

#Phase Particles
execute as @e[type=wither_skeleton,tag=thor_boss,scores={thor_Health=..300}] at @s run particle minecraft:electric_spark ~ ~1.25 ~ 0.25 0.5 0.25 0 5 force @a

#Jump Attack
execute as @e[type=wither_skeleton,tag=thor_boss,tag=!intro,tag=!jumped,scores={thor_Attack=47..48,thor_Health=..300}] at @s if predicate techno_gow_weapons:is_target_in_melee_range if predicate techno_gow_weapons:random/25_per_cent run function techno_gow_weapons:bosses/thor/jump
execute as @e[type=wither_skeleton,tag=thor_boss,tag=!intro,tag=jumped,scores={thor_Attack=49..,thor_Health=..300}] at @s run tag @s add falling
execute as @e[type=wither_skeleton,tag=thor_boss,tag=!intro,tag=falling,nbt={OnGround:1b}] at @s run function techno_gow_weapons:bosses/thor/lightning

#Bossbar
execute as @e[type=wither_skeleton,tag=thor_boss] at @s run bossbar set minecraft:thor_health players @a[distance=..36]
execute as @a at @s store result bossbar minecraft:thor_health value run data get entity @e[type=minecraft:wither_skeleton,tag=thor_boss,sort=nearest,limit=1,distance=..36] Health
execute as @e[type=wither_skeleton,tag=thor_boss] at @s store result score @s thor_Health run data get entity @e[type=minecraft:wither_skeleton,tag=thor_boss,sort=nearest,limit=1,distance=..36] Health
execute unless entity @e[type=wither_skeleton,tag=thor_boss] run bossbar set minecraft:thor_health players

#Boss Music
execute as @a[gamemode=!creative,gamemode=!spectator] at @s unless entity @s[scores={thor_Music=1..}] if entity @e[type=wither_skeleton,tag=thor_boss,tag=!intro,distance=..36] run scoreboard players set @s thor_Music 1
execute as @a[scores={thor_Music=1..}] at @s if entity @e[type=wither_skeleton,tag=!intro,tag=thor_boss,distance=..36] run scoreboard players add @s thor_Music 1
execute as @a[scores={thor_Music=1..}] at @s unless entity @e[type=wither_skeleton,tag=!intro,tag=thor_boss,distance=..36] run scoreboard players set @s thor_Music 0
execute as @a[scores={thor_Music=1..}] at @s unless entity @s[gamemode=!creative,gamemode=!spectator] run scoreboard players set @s thor_Music 0
execute as @a[scores={thor_Music=0}] at @s run function techno_gow_weapons:bosses/thor/victory
execute as @a[scores={thor_Music=1..2}] at @s run playsound minecraft:custom.bosses.music.thor.battle master @s ~ ~ ~ 1 1
scoreboard players set @a[scores={thor_Music=2200..}] thor_Music 1

#Intro
function techno_gow_weapons:bosses/thor/intro
execute as @e[tag=thor_boss,tag=intro] at @s run effect give @s resistance 1 200 true

#Animations
function techno_gow_weapons:bosses/thor/animations